DevExtreme jQuery/JS - Getting Started with Navigation Drawer

NOTE
Before starting the tutorial, make sure that you have installed DevExtreme in your application as described in the Installation section (for JavaScript libraries), the Getting Started article (for ASP.NET MVC 5 Controls), or the Configure a Visual Studio Project article (for ASP.NET Core Controls).

The Drawer is a dismissible or permanently visible panel used for navigation in responsive web application layouts.

DevExtreme provides an application template for Angular. It implements a responsive layout that uses the Drawer. You can use this template instead of following the tutorial. Refer to the documentation on GitHub for more information.

If you do not use Angular or the template is unsuitable, follow the instructions in this tutorial. We create a Drawer that allows a user to switch between pages. The Drawer is opened and closed via a button on a toolbar.

Refer to the subtopics for details on every configuration step. You can also see the full code below:

index.js
index.html
style.css
inbox.html
sent-mail.html
trash.html
spam.html
  • $(function() {
  • $("#view").load( "./inbox.html" );
  •  
  • $("#toolbar").dxToolbar({
  • items: [{
  • widget: "dxButton",
  • location: "before",
  • options: {
  • icon: "menu",
  • onClick: function() {
  • drawer.toggle();
  • }
  • }
  • }]
  • });
  •  
  • var drawer = $("#drawer").dxDrawer({
  • minSize: 37,
  • height: 250,
  • revealMode: "expand",
  • openedStateMode: "overlap",
  • template: function() {
  • var $list = $("<div/>").dxList({
  • items: [
  • { id: 1, text: "Inbox", icon: "message", filePath: "inbox" },
  • { id: 2, text: "Sent Mail", icon: "check", filePath: "sent-mail" },
  • { id: 3, text: "Trash", icon: "trash", filePath: "trash" },
  • { id: 4, text: "Spam", icon: "mention", filePath: "spam" }
  • ],
  • width: 200,
  • height: 200,
  • selectionMode: "single",
  • onSelectionChanged: function(e) {
  • $("#view").load( e.addedItems[0].filePath + ".html" );
  • }
  • });
  • return $list;
  • }
  • }).dxDrawer("instance");
  • })
  • <html>
  • <head>
  • <!-- ... -->
  • <script type="text/javascript" src="https://code.jquery.com/jquery-3.5.1.min.js"></script>
  • <link rel="stylesheet" href="https://cdn3.devexpress.com/jslib/19.1.16/css/dx.common.css">
  • <link rel="stylesheet" href="https://cdn3.devexpress.com/jslib/19.1.16/css/dx.light.css">
  • <script type="text/javascript" src="https://cdn3.devexpress.com/jslib/19.1.16/js/dx.all.js"></script>
  • <script type="text/javascript" src="index.js"></script>
  • </head>
  • <body>
  • <div id="toolbar"></div>
  • <div id="drawer">
  • <div id="view"></div>
  • </div>
  • </body>
  • </html>
  • .dx-drawer-panel-content, .dx-overlay-content {
  • background-color: lightgray;
  • }
  • #toolbar {
  • background-color: rgba(191, 191, 191, .15);
  • padding: 5px 10px;
  • }
  • .dx-toolbar-button .dx-button {
  • background-color: rgba(191, 191, 191, -0.15);
  • border: none;
  • }
  • .dx-toolbar-button > .dx-toolbar-item-content {
  • margin-left: -7px;
  • }
  • .dx-list-item-icon {
  • margin-right: 10px;
  • }
  • #view {
  • margin-left: 10px;
  • margin-top: 10px;
  • }
  • <div>Inbox</div>
  • <div>Sent Mail</div>
  • <div>Trash</div>
  • <div>Spam</div>

Create the Drawer

Wrap the view in the Drawer and specify a template for the Drawer's content. Inside the template, set the Drawer's width. You can use the nested widget's width option for this (see Implement Navigation), but in this tutorial, we use the width CSS property. The Drawer's height adjusts to the view's height (specified via the height option).

In addition, you can specify the minSize option to make the Drawer partially visible in the closed state.

index.html
index.js
style.css
  • <html>
  • <head>
  • <!-- ... -->
  • <script type="text/javascript" src="https://code.jquery.com/jquery-3.5.1.min.js"></script>
  • <link rel="stylesheet" href="https://cdn3.devexpress.com/jslib/19.1.16/css/dx.common.css">
  • <link rel="stylesheet" href="https://cdn3.devexpress.com/jslib/19.1.16/css/dx.light.css">
  • <script type="text/javascript" src="https://cdn3.devexpress.com/jslib/19.1.16/js/dx.all.js"></script>
  • <script type="text/javascript" src="index.js"></script>
  • </head>
  • <body>
  • <div id="drawer">
  • <div id="view">View content</div>
  • </div>
  • </body>
  • </html>
  • $(function() {
  • $("#drawer").dxDrawer({
  • template: function(e) {
  • return $("<div style='width: 150px'>Drawer content</div>");
  • },
  • height: 250,
  • minSize: 37
  • });
  • });
  • .dx-drawer-panel-content, .dx-overlay-content {
  • background-color: lightgray;
  • }
  • #view {
  • margin-left: 10px;
  • margin-top: 10px;
  • }

If you run the code, you should see a partially visible Drawer and a view that displays View content.

Open and Close the Drawer

Depending on the library or framework you use, call the toggle() method or bind a variable to the opened option.

In the following code, a toolbar button outside the Drawer opens and closes it:

index.js
index.html
style.css
  • $(function() {
  • var drawer = $("#drawer").dxDrawer({
  • // ...
  • }).dxDrawer("instance");
  • $("#toolbar").dxToolbar({
  • items: [{
  • widget: "dxButton",
  • location: "before",
  • options: {
  • icon: "menu",
  • onClick: function() {
  • drawer.toggle();
  • }
  • }
  • }]
  • });
  • })
  • <div id="toolbar"></div>
  • <div id="drawer">
  • <div id="view">View content</div>
  • </div>
  • /* ... */
  • #toolbar {
  • background-color: rgba(191, 191, 191, .15);
  • padding: 5px 10px;
  • }
  • .dx-toolbar-button .dx-button {
  • background-color: rgba(191, 191, 191, -0.15);
  • border: none;
  • }
  • .dx-toolbar-button > .dx-toolbar-item-content {
  • margin-left: -7px;
  • }

Implement Navigation

The Drawer is designed to contain navigation items. If they should nest other items, use the TreeView widget to implement navigation. Otherwise, use the List.

These widgets provide the onSelectionChanged function in which we can implement the navigation logic. However, this function is executed only if you enable selection. In the TreeView, set the selectionMode to "single" and assign true to selectByClick; in the List, set the selectionMode to "single".

In this tutorial, we use the List:

index.js
index.html
style.css
inbox.html
sent-mail.html
trash.html
spam.html
  • $(function() {
  • // Loads the initial page
  • $("#view" ).load( "./inbox.html" );
  •  
  • var drawer = $("#drawer").dxDrawer({
  • // ...
  • template: function(e) {
  • var $list = $("<div/>").dxList({
  • items: [
  • { id: 1, text: "Inbox", icon: "message", filePath: "inbox" },
  • { id: 2, text: "Sent Mail", icon: "check", filePath: "sent-mail" },
  • { id: 3, text: "Trash", icon: "trash", filePath: "trash" },
  • { id: 4, text: "Spam", icon: "mention", filePath: "spam" }
  • ],
  • width: 200,
  • selectionMode: "single",
  • onSelectionChanged: function(e) {
  • $("#view").load( e.addedItems[0].filePath + ".html" );
  • }
  • });
  • return $list;
  • }
  • }).dxDrawer("instance");
  • })
  • <div id="toolbar"></div>
  • <div id="drawer">
  • <div id="view"></div>
  • </div>
  • /* ... */
  • .dx-list-item-icon {
  • margin-right: 10px;
  • }
  • <div>Inbox</div>
  • <div>Sent Mail</div>
  • <div>Trash</div>
  • <div>Spam</div>

Run the code, open the Drawer, and click its items to change the views.

Configure the Reveal Behavior

When you open the Drawer, it can slide in or expand from the closed position. Use the revealMode option to specify this behavior.

index.js
  • $(function() {
  • var drawer = $("#drawer").dxDrawer({
  • // ...
  • revealMode: "expand"
  • }).dxDrawer("instance");
  • })

Run the code and open the Drawer. You should see that the widget gets wider, but its content stays in place, creating an impression that the Drawer expands.

Configure Interaction with the View

When the Drawer opens, it can overlap, shrink, or partially displace the view, depending on the openedStateMode option:

index.js
  • $(function() {
  • var drawer = $("#drawer").dxDrawer({
  • // ...
  • openedStateMode: "overlap"
  • }).dxDrawer("instance");
  • })

Run the code, open the Drawer and you should see that it overlaps the view's text.

Change the Position

You can use the position option to anchor the Drawer to any side of the view. In this tutorial, the Drawer is in its default position (left).

You have configured basic Drawer features. For more information about this widget, explore the following resources:

DevExtreme React - Getting Started with Navigation Drawer

NOTE
Before starting the tutorial, make sure that you have installed DevExtreme in your application as described in the Installation section (for JavaScript libraries), the Getting Started article (for ASP.NET MVC 5 Controls), or the Configure a Visual Studio Project article (for ASP.NET Core Controls).

The Drawer is a dismissible or permanently visible panel used for navigation in responsive web application layouts.

DevExtreme supplies application templates for Angular, Vue, and React. They implement a responsive layout that uses the Drawer. You can use these templates instead of following the tutorial. Refer to the documentation on GitHub for more information:

If the templates are unsuitable or you use jQuery, follow the instructions in this tutorial. We create a Drawer that allows a user to switch between pages. The Drawer is opened and closed via a button on a toolbar.

Refer to the subtopics for details on every configuration step. You can also see the full code below:

DxComponent.js
NavigationList.js
App.js
history.js
DxComponent.css
Inbox.js
SentMail.js
Spam.js
Trash.js
  • import React from "react";
  •  
  • import "devextreme/dist/css/dx.common.css";
  • import "devextreme/dist/css/dx.light.css";
  • import "./DxComponent.css";
  •  
  • import { Drawer } from "devextreme-react/drawer";
  • import { Toolbar, Item } from "devextreme-react/toolbar";
  • import NavigationList from "./NavigationList";
  •  
  • import { Router, Route } from "react-router-dom";
  •  
  • import Inbox from "./views/Inbox";
  • import Trash from "./views/Trash";
  • import SentMail from "./views/SentMail";
  • import Spam from "./views/Spam";
  •  
  • import history from "./history";
  •  
  • class DxComponent extends React.Component {
  • constructor(props) {
  • super(props);
  •  
  • this.state = {
  • isDrawerOpen: false
  • };
  • this.buttonOptions = {
  • icon: "menu",
  • onClick: () => {
  • this.setState({ isDrawerOpen: !this.state.isDrawerOpen });
  • }
  • };
  • }
  •  
  • renderList = () => {
  • const stateHandler = (newState) => this.setState(newState);
  • return (
  • <NavigationList stateHandler={stateHandler} />
  • );
  • }
  •  
  • render() {
  • return (
  • <React.Fragment>
  • <Toolbar id="toolbar">
  • <Item
  • widget="dxButton"
  • options={this.buttonOptions}
  • location="before" />
  • </Toolbar>
  • <Drawer
  • minSize={37}
  • height={250}
  • revealMode="expand"
  • openedStateMode="overlap"
  • render={this.renderList}
  • opened={this.state.isDrawerOpen} >
  • <div id="view">
  • <Router history={history}>
  • <div>
  • <Route exact path="/" component={Inbox} />
  • <Route exact path="/inbox" component={Inbox} />
  • <Route exact path="/sent-mail" component={SentMail} />
  • <Route exact path="/spam" component={Spam} />
  • <Route exact path="/trash" component={Trash} />
  • </div>
  • </Router>
  • </div>
  • </Drawer>
  • </React.Fragment>
  • );
  • }
  • }
  • export default DxComponent;
  • import React from "react";
  • import List from "devextreme-react/list";
  • import history from "./history";
  •  
  • const navigation = [
  • { id: 1, text: "Inbox", icon: "message", filePath: "inbox" },
  • { id: 2, text: "Sent Mail", icon: "check", filePath: "sent-mail" },
  • { id: 3, text: "Trash", icon: "trash", filePath: "trash" },
  • { id: 4, text: "Spam", icon: "mention", filePath: "spam" }
  • ];
  •  
  • class NavigationList extends React.PureComponent {
  • loadView = (e) => {
  • history.push(e.addedItems[0].filePath);
  • this.props.stateHandler({ isDrawerOpen: false });
  • }
  • render() {
  • return (
  • <React.Fragment>
  • <List
  • items={navigation}
  • width={200}
  • selectionMode="single"
  • onSelectionChanged={this.loadView} />
  • </React.Fragment>
  • );
  • }
  • }
  • export default NavigationList;
  • import React, { Component } from "react";
  • import DxComponent from "./components/DxComponent";
  •  
  • class App extends Component {
  • render() {
  • return (
  • <div className="App">
  • <DxComponent />
  • </div>
  • );
  • }
  • }
  • export default App;
  • import { createBrowserHistory } from "history"
  •  
  • export default createBrowserHistory()
  • .dx-overlay-content {
  • background-color: lightgray;
  • }
  • #toolbar {
  • background-color: rgba(191, 191, 191, .15);
  • padding: 5px 10px;
  • }
  • .dx-toolbar-button .dx-button {
  • background-color: rgba(191, 191, 191, -0.15);
  • border: none;
  • }
  • .dx-toolbar-button > .dx-toolbar-item-content {
  • margin-left: -7px;
  • }
  • .dx-list-item-icon {
  • margin-right: 10px;
  • }
  • #view {
  • margin-left: 10px;
  • margin-top: 10px;
  • }
  • import React from "react";
  •  
  • class Inbox extends React.Component {
  • render() {
  • return (
  • <div>Inbox</div>
  • );
  • }
  • }
  • export default Inbox;
  • import React from "react";
  •  
  • class SentMail extends React.Component {
  • render() {
  • return (
  • <div>Sent Mail</div>
  • );
  • }
  • }
  • export default SentMail;
  • import React from "react";
  •  
  • class Spam extends React.Component {
  • render() {
  • return (
  • <div>Spam</div>
  • );
  • }
  • }
  • export default Spam;
  • import React from "react";
  •  
  • class Trash extends React.Component {
  • render() {
  • return (
  • <div>Trash</div>
  • );
  • }
  • }
  • export default Trash;

Create the Drawer

Wrap the view in the Drawer and specify a template for the Drawer's content. Inside the template, set the Drawer's width. You can use the nested widget's width option for this (see Implement Navigation), but in this tutorial, we use the width CSS property. The Drawer's height adjusts to the view's height (specified via the height option).

In addition, you can specify the minSize option to make the Drawer partially visible in the closed state.

DxComponent.js
DxComponent.css
App.js
  • import React from "react";
  •  
  • import "devextreme/dist/css/dx.common.css";
  • import "devextreme/dist/css/dx.light.css";
  • import "./DxComponent.css";
  •  
  • import { Drawer } from "devextreme-react/drawer";
  •  
  • class DxComponent extends React.Component {
  • constructor(props) {
  • super(props);
  • }
  • render() {
  • return (
  • <React.Fragment>
  • <Drawer
  • minSize={37}
  • height={250}
  • render={ () => <div style="width: 150px">Drawer content</div> } >
  • <div>View content</div>
  • </Drawer>
  • </React.Fragment>
  • );
  • }
  • }
  • export default DxComponent;
  • .dx-overlay-content {
  • background-color: lightgray;
  • }
  • #view {
  • margin-left: 10px;
  • margin-top: 10px;
  • }
  • import React, { Component } from "react";
  •  
  • import DxComponent from "./components/DxComponent";
  •  
  • class App extends Component {
  • render() {
  • return (
  • <div className="App">
  • <DxComponent />
  • </div>
  • );
  • }
  • }
  • export default App;

If you run the code, you should see a partially visible Drawer and a view that displays View content.

Open and Close the Drawer

Depending on the library or framework you use, call the toggle() method or bind the opened option to a component property.

In the following code, a toolbar button outside the Drawer opens and closes it:

DxComponent.js
DxComponent.css
  • // ...
  • import { Drawer } from "devextreme-react/drawer";
  • import { Toolbar, Item } from "devextreme-react/toolbar";
  •  
  • class DxComponent extends React.Component {
  • constructor(props) {
  • super(props);
  • this.state = {
  • isDrawerOpen: false
  • };
  • this.buttonOptions = {
  • icon: "menu",
  • onClick: () => {
  • this.setState({ isDrawerOpen: !this.state.isDrawerOpen })
  • }
  • };
  • }
  • render() {
  • return (
  • <React.Fragment>
  • <Toolbar id="toolbar">
  • <Item
  • widget="dxButton"
  • options={this.buttonOptions}
  • location="before" />
  • </Toolbar>
  • <Drawer ...
  • opened={this.state.isDrawerOpen} >
  • <div>View content</div>
  • </Drawer>
  • </React.Fragment>
  • );
  • }
  • }
  • export default DxComponent;
  • /* ... */
  • #toolbar {
  • background-color: rgba(191, 191, 191, .15);
  • padding: 5px 10px;
  • }
  • .dx-toolbar-button .dx-button {
  • background-color: rgba(191, 191, 191, -0.15);
  • border: none;
  • }
  • .dx-toolbar-button > .dx-toolbar-item-content {
  • margin-left: -7px;
  • }

Implement Navigation

The Drawer is designed to contain navigation items. If they should nest other items, use the TreeView widget to implement navigation. Otherwise, use the List.

These widgets provide the onSelectionChanged function in which we can implement the navigation logic. However, this function is executed only if you enable selection. In the TreeView, set the selectionMode to "single" and assign true to selectByClick; in the List, set the selectionMode to "single".

In this tutorial, we use the List:

DxComponent.js
NavigationList.js
history.js
DxComponent.css
Inbox.js
SentMail.js
Spam.js
Trash.js
  • // ...
  • import NavigationList from "./NavigationList";
  •  
  • import { Router, Route } from "react-router-dom";
  •  
  • import Inbox from "./views/Inbox";
  • import Trash from "./views/Trash";
  • import SentMail from "./views/SentMail";
  • import Spam from "./views/Spam";
  •  
  • import history from "./history";
  •  
  • class DxComponent extends React.Component {
  • renderList = () => {
  • const stateHandler = (newState) => this.setState(newState);
  • return (
  • <NavigationList stateHandler={stateHandler} />
  • );
  • }
  •  
  • render() {
  • return (
  • <React.Fragment>
  • <Drawer ...
  • render={this.renderList}>
  • <div id="view">
  • <Router history={history}>
  • <div>
  • <Route exact path="/" component={Inbox} />
  • <Route exact path="/inbox" component={Inbox} />
  • <Route exact path="/sent-mail" component={SentMail} />
  • <Route exact path="/spam" component={Spam} />
  • <Route exact path="/trash" component={Trash} />
  • </div>
  • </Router>
  • </div>
  • </Drawer>
  • </React.Fragment>
  • );
  • }
  • }
  • export default DxComponent;
  • import React from "react";
  • import List from "devextreme-react/list";
  • import history from "./history";
  •  
  • const navigation = [
  • { id: 1, text: "Inbox", icon: "message", filePath: "inbox" },
  • { id: 2, text: "Sent Mail", icon: "check", filePath: "sent-mail" },
  • { id: 3, text: "Trash", icon: "trash", filePath: "trash" },
  • { id: 4, text: "Spam", icon: "mention", filePath: "spam" }
  • ];
  •  
  • class NavigationList extends React.PureComponent {
  • loadView(e) {
  • history.push(e.addedItems[0].filePath);
  • this.props.stateHandler({ isDrawerOpen: false });
  • }
  • render() {
  • return (
  • <React.Fragment>
  • <List
  • items={navigation}
  • width={200}
  • selectionMode="single"
  • onSelectionChanged={this.loadView} />
  • </React.Fragment>
  • );
  • }
  • }
  • export default NavigationList;
  • import { createBrowserHistory } from "history";
  •  
  • export default createBrowserHistory()
  • /* ... */
  • .dx-list-item-icon {
  • margin-right: 10px;
  • }
  • import React from "react";
  •  
  • class Inbox extends React.Component {
  • render() {
  • return (
  • <div>Inbox</div>
  • );
  • }
  • }
  • export default Inbox;
  • import React from "react";
  •  
  • class SentMail extends React.Component {
  • render() {
  • return (
  • <div>Sent Mail</div>
  • );
  • }
  • }
  • export default SentMail;
  • import React from "react";
  •  
  • class Spam extends React.Component {
  • render() {
  • return (
  • <div>Spam</div>
  • );
  • }
  • }
  • export default Spam;
  • import React from "react";
  •  
  • class Trash extends React.Component {
  • render() {
  • return (
  • <div>Trash</div>
  • );
  • }
  • }
  • export default Trash;

Run the code, open the Drawer, and click its items to change the views.

Configure the Reveal Behavior

When you open the Drawer, it can slide in or expand from the closed position. Use the revealMode option to specify this behavior.

DxComponent.js
  • // ...
  • class DxComponent extends React.Component {
  • // ...
  • render() {
  • return (
  • <React.Fragment>
  • <Drawer ...
  • revealMode="expand" >
  • </Drawer>
  • </React.Fragment>
  • );
  • }
  • }
  • export default DxComponent;

Run the code and open the Drawer. You should see that the widget gets wider, but its content stays in place, creating an impression that the Drawer expands.

Configure Interaction with the View

When the Drawer opens, it can overlap, shrink, or partially displace the view, depending on the openedStateMode option:

DxComponent.js
  • // ...
  • class DxComponent extends React.Component {
  • // ...
  • render() {
  • return (
  • <React.Fragment>
  • <Drawer ...
  • openedStateMode="overlap" >
  • </Drawer>
  • </React.Fragment>
  • );
  • }
  • }
  • export default DxComponent;

Run the code, open the Drawer and you should see that it overlaps the view's text.

Change the Position

You can use the position option to anchor the Drawer to any side of the view. In this tutorial, the Drawer is in its default position (left).

You have configured basic Drawer features. For more information about this widget, explore the following resources: